"use strict";
var immutable_1 = require("immutable");
/**
 * Applies a function to every key-value pair inside an object.
 *
 * @param {Object} obj The source object.
 * @param {Function} fn The mapper function that receives the value and the key.
 * @returns {Object} A new object that contains the mapped values for the keys.
 */
function mapValues(obj, fn) {
    return Object.keys(obj).reduce(function (result, key) { return (result.set(key, fn(obj[key], key))); }, immutable_1.Map());
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = mapValues;
